// weatherClient.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <string>
#include <iostream>
using namespace std;

#include <http_client.h>
using namespace web;
using namespace web::http;
using namespace web::http::client;

int _tmain(int argc, _TCHAR* argv[])
{
	vector<wstring> cities = { L"Milano", L"London,uk", L"Paris,fr", L"New York,us", L"Genova", L"Lausanne,ch" };
	
	vector<pplx::task<void>> queries;
	for (const auto& city : cities)
	{
		// Create an HTTP request.
		// Encode the URI query since it could contain special characters like spaces.
		http_client client(L"http://api.openweathermap.org/");
		auto uri = uri_builder(L"/data/2.5/weather")
			.append_query(L"q", city)
			.append_query(L"units", L"metric")
			.to_string();

		auto task = client.request(methods::GET, uri)
			.then([city](http_response response) -> pplx::task<json::value>
		{
			if (response.status_code() == status_codes::OK) {
				return response.extract_json();
			}
			else {
				return pplx::task_from_result(json::value());
			}
		}).then([city](json::value value)
		{
			auto temperature = value[L"main"][L"temp"].as_double();
			fprintf(stdout, "%S : %.1f\n", city.c_str(), temperature);
		});
		queries.push_back(task);
	}

	Concurrency::when_all(std::begin(queries), std::end(queries)).get();

	return 0;
}
